=== modified file 'olive.glade'
--- olive.glade	2008-03-04 14:14:42 +0000
+++ olive.glade	2008-03-30 14:12:10 +0000
@@ -515,6 +515,7 @@
                     <property name="can_focus">True</property>
                     <property name="headers_visible">False</property>
                     <signal name="button_press_event" handler="on_treeview_left_button_press_event"/>
+                    <signal name="button_release_event" handler="on_treeview_left_button_release_event"/>
                     <signal name="row_activated" handler="on_treeview_left_row_activated"/>
                   </widget>
                 </child>

=== modified file 'olive/__init__.py'
--- olive/__init__.py	2008-03-30 14:11:42 +0000
+++ olive/__init__.py	2008-03-30 14:12:10 +0000
@@ -198,6 +198,7 @@
                 "on_treeview_right_button_press_event": self.on_treeview_right_button_press_event,
                 "on_treeview_right_row_activated": self.on_treeview_right_row_activated,
                 "on_treeview_left_button_press_event": self.on_treeview_left_button_press_event,
+                "on_treeview_left_button_release_event": self.on_treeview_left_button_release_event,
                 "on_treeview_left_row_activated": self.on_treeview_left_row_activated,
                 "on_button_location_up_clicked": self.on_button_location_up_clicked,
                 "on_button_location_jump_clicked": self.on_button_location_jump_clicked,
@@ -810,6 +811,20 @@
             menu.left_context_menu().popup(None, None, None, 0,
                                            event.time)
 
+    def on_treeview_left_button_release_event(self, widget, event):
+        """ Occurs when somebody just clicks a bookmark. """
+        if event.button != 3:
+            # Allow one-click bookmark opening
+            if self.get_selected_left() == None:
+                return
+            
+            newdir = self.get_selected_left()
+            if newdir == None:
+                return
+
+            if self.set_path(newdir):
+                self.refresh_right()
+
     def on_treeview_left_row_activated(self, treeview, path, view_column):
         """ Occurs when somebody double-clicks or enters an item in the
         bookmark list. """

